function colors() {
}

colors.$drag = false;
colors.$drag_object = null;

colors.set_drag = function($e)
{
    colors.$drag = true;
    colors.$drag_object = $('<span tcolor="' + $e.attr('tcolor') + '">' + $e.attr('tcolor') + '</span>');
    colors.$drag_object.css('position', 'absolute');
    $('body').append(colors.$drag_object);
    colors.$drag_object.data('parent', $e);
    colors.$drag_object.css({fontSize: '25px', fontWeight: 'bold', zIndex: 25});
};

colors.init_drag = function($color_element)
{
    $color_element.mousedown(function($e)
    {
        var $offsetX = parseInt($(this).css('left')) - $e.pageX;
        var $offsetY = parseInt($(this).css('top')) - $e.pageY;
        $(this).data({mousedown: true, x: $e.pageX, y: $e.pageY, offsetX: $offsetX, offsetY: $offsetY});

        return false;
    }).mouseup(function()
    {
        $(this).data('mousedown', false);
    }).mousemove(function($e)
    {
        if (Math.abs($(this).data('x') - $e.pageX) + Math.abs($(this).data('y') - $e.pageY) > 2 && $(this).data('mousedown') && !colors.$drag)
        {
            colors.set_drag($(this));
        }
    }).mouseleave(function()
    {
        if ($(this).data('mousedown') && !colors.$drag)
        {
            colors.set_drag($(this));
        }
    });
};

colors.init_set_color_up = function($e)
{
    $e.mouseup(function()
    {
        if (colors.$drag_object !== null)
        {
            var $s = colors.$drag_object.text();
            $(this).css('background', '#' + $s);
            $(this).attr('tcolor', $s);
            $(this).attr('title', '#' + $s);
        }
    });
};

colors.createAllColores = function()
{
    var c = 0;
    var $id = 0;
    var $X = 51;
    var max = (51 / $X) * 5;
    var $palitra = $('#palitra');
    $palitra.empty();
    for (var $r = 0; $r <= max; $r++)
    {
        var $big_block = $('<div class="big-block" />');
        for (var $g = 0; $g <= max; $g++)
        {
            for (var $b = 0; $b <= max; $b++)
            {
                $id++;
                c = '';
                var n = Math.round($r * $X);
                n = n.toString(16);
                if (n.length <= 1)
                {
                    n = '0' + n;
                }
                c += n;
                n = Math.round($g * $X);
                n = n.toString(16);
                if (n.length <= 1)
                {
                    n = '0' + n;
                }
                c += n;
                n = Math.round($b * $X);
                n = n.toString(16);
                if (n.length <= 1)
                {
                    n = '0' + n;
                }
                c += n;
                var $color_block = $('<div class="color-block" tcolor="' + c + '" title="#' + c + '"/>');
                $color_block.css('background', '#' + c);
                colors.init_drag($color_block);
                $big_block.append($color_block);
            }
        }
        $palitra.append($big_block);
    }
    $palitra.append('<div class="clear" />');
};

colors.set_tcolor_text_result = function()
{
    var $tcr = $('#past_color_result');
    var $color = '';
    var $result = null;
    $('.tcolor-input').each(function()
    {
        $color += $(this).val();
        var $preg = /[0-9a-fA-F]{6}/;
        $result = $color.match($preg);
    });
    
    if ($result !== null)
    {
        $tcr.css('background', '#' + $color);
        $tcr.attr('tcolor', $color);
        $tcr.attr('title', '#' + $color);
    }
};

(function($)
{
    colors.createAllColores();
    $(document).mouseup(function()
    {
        colors.$drag = false;
        if (colors.$drag_object !== null)
        {
            var $p = colors.$drag_object.data('parent');
            $p.data('mousedown', false);
            colors.$drag_object.remove();
        }

        colors.$drag_object = null;

    }).mousemove(function($e)
    {
        if (colors.$drag && colors.$drag_object !== null)
        {
            var $x = $e.pageX + 20;
            var $y = $e.pageY + 20;
            colors.$drag_object.css({top: $y, left: $x});
        }
    });

    colors.init_drag($('#past_color_result'));

    $('.tcolor-input').keyup(function()
    {
        if ($(this).data('keydown'))
        {
            if ($(this).val().length > 1)
            {
                $(this).next('.tcolor-input').focus().select();
            }
            else if ($(this).val().length === 0)
            {
                $(this).prev('.tcolor-input').focus().select();
            }
        }

        $(this).data('keydown', false);
        colors.set_tcolor_text_result();
    }).keydown(function()
    {
        $(this).data('keydown', true);
    }).on('mousewheel', function($e)
    {
        var $t = $(this).val() === '' ? '00' : $(this).val();
        var $n = parseInt($t, 16);
        if ($e.originalEvent.deltaY < 0) // top
        {
            $n += 6;
        }
        else
        {
            $n -= 6;
        }
        if ($n <= 0)
        {
            $n = 0;
        }
        else if ($n > 255)
        {
            $n = 255;
        }

        var $result = $n.toString(16).length < 2 ? '0' + $n.toString(16) : $n.toString(16);
        $(this).val($result);
        colors.set_tcolor_text_result();
    });

    $('#past_color_result').mouseup(function()
    {
        if (colors.$drag_object !== null)
        {
            var $s = colors.$drag_object.text();
            $(this).css('background', '#' + $s);
            $(this).attr('tcolor', $s);
            $(this).attr('title', '#' + $s);
            $('#R').val($s.substr(0, 2));
            $('#G').val($s.substr(2, 2));
            $('#B').val($s.substr(4, 2));
        }
    });

})(jQuery);

